/*
  PromptNuFlux flux_interpolation.hh
  Author: Luca Rottoli, 2015
*/

#pragma once

#include <cmath>
#include <cstdlib>
#include <iostream>
#include <fstream>

#include <gsl/gsl_spline.h>

#include "common.hh"

using namespace std;

class FluxInterpolation
{

public:

	FluxInterpolation();
	~FluxInterpolation();
	FluxInterpolation( const FluxInterpolation& other );
	
	double CentralFlux(double E, fluxmodel flux=BPL);
	double UpperFlux  (double E, fluxmodel flux=BPL);
	double LowerFlux  (double E, fluxmodel flux=BPL);

private:

	FluxInterpolation& operator=( const FluxInterpolation& other );

	int fNPoints;
	int fNModels;

	gsl_spline ** fSplineC;
	gsl_spline ** fSplineU;
	gsl_spline ** fSplineL;

};